----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------

Ball = class('Ball')

function Ball:initialize(x, y, r, hv, vv) -- I wrote paddle.lua first so see that for documentation
	local lp = love.physics
	
	self.body = lp.newBody(world, x + r, y + r, "dynamic") -- so balls dont collide with eachother we set it to kinematic
	self.shape = lp.newCircleShape(r)
	self.fixture = lp.newFixture(self.body, self.shape)
	
	self.hv = hv --horizontal velocity
	self.vv = vv --vertical velocity
	
	self.color = { 255*math.random(), 255*math.random(), 255*math.random() }
	self.order = math.random()
	self.sound = nil
	self.steps = nil
	self.fixture:setRestitution(.9) --bouncy-ness
	self.fixture:setUserData("Ball")
end

function Ball:draw()
	local lg = love.graphics
	lg.setColor(self.color)
	lg.circle("fill", self.body:getX(), self.body:getY(), self.shape:getRadius())
end

function Ball:update(dt)
	self.body:setLinearVelocity(self.hv, self.vv)
end

function Ball:destroy()
	for i = 1, #balls do
		if balls[i] == self then
			balls[i] = deleted
		end
	end
	customSort(balls)
end




