----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------
Button = class("Button")


function Button:initialize(x, y, text, state)
	self.x = x
	self.y = y
	self.text = text
	self.font = bigFont
	self.color = { 255, 236, 139 }
	self.gotoState = state
end

function Button:draw()
	love.graphics.setFont(self.font)
	love.graphics.setColor(self.color)
	love.graphics.print(self.text, self.x, self.y)
end

function Button:hover()
	self.color = { 255, 215, 0 }
end

function Button:click()
	self.color = { 205, 173, 0 }
	if self.gotoState == "game" then
		switchState(game)
		pushState(pregame)
	elseif self.gotoState == "title" then
		if #states == help or #states == options then popState() end
		switchState(title)
	elseif self.gotoState == "help" then
		pushState(help)
	elseif self.gotoState == "options" then
		pushState(options)
	elseif self.gotoState == "exit" then
		love.event.push('quit')
	end
end

function Button:idle()
	self.color = { 255, 236, 139 }
end