----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------

GameState = class("GameState")

function GameState:initialize() --accepts a numeric difficulty
	--we always want to draw this behind the other states, we will draw it first because we don't draw anything else until the end of the table
	--if we wanted to draw multiple states at once we need to be aware of what order they are in in the table, earlier ones are in the back.
	self.alwaysDraw = true   
	self.alwaysUpdate = false
	paddles[#paddles+1] = Paddle(100, 100, 75, 25)
	balls[#balls+1] = Ball(10, HEIGHT - 30, 15, 100, -100)

end

function GameState:draw()
	local lg = love.graphics
	lg.setColor(255, 255, 255)
	lg.setFont(smallFont)
	if self == states[#states] then
		lg.print("We are playing a game! \nPress W to see who wins or \nPress P to pause!", 20, 20)
	else
		lg.print("we are waiting to play! \nWe have " ..#states .. " active states right now", 20, 20)
	end
	
	for _, paddle in ipairs(paddles) do
		paddle:draw()
	end
	
	for _, ball in ipairs(balls) do
		ball:draw()
	end
	
end

function GameState:update(dt)
	world:update(dt) --update our physics world
	for _, paddle in ipairs(paddles) do
		if self == states[#states] then --only update if we are the active state
			paddle:update(dt) --equivalent to paddles[i]:update()
		else
			paddle:pause()
		end
	end
	
	for _, ball in ipairs(balls) do
		if self == states[#states] then
			ball:update()
		else
			ball:pause()
		end
	end
		
end

function GameState:destroy()
	-- things that will go in here will likely be
	-- objects you want to destroy, like players, or bullets or what have you
end

function GameState:setCallbacks()
	function love.keypressed(k)
		if states[#states] == self then --we dont want callbacks happening if we aren't the active state
			if k == "w" then
				postgame = PostGameState(math.random(1,2))
				pushState(postgame) --by pushing we still will see preserve game in the background, if postgame doesn't draw over/clear everything
			end
		
			if k == "p" then
				pause = PauseState()
				pushState(pause) --again by pushing we preserve our precious game
			end
		end
	end
	
	function love.mousereleased(x,y,k)
	end
end