----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------

HelpState = class('HelpState')

function HelpState:initialize()
	self.alwaysUpdate = false
	self.alwaysDraw = false
	self.buttons = {}
	self.buttons[#self.buttons+1] = Button(WIDTH/2 - 75, HEIGHT/2 + 100, "Exit", "title")
end

function HelpState:draw()
	for _ = 1, #self.buttons do
		if self.buttons[_] then self.buttons[_]:draw() end
	end
end

function HelpState:update(dt)
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	
	for _, button in ipairs(self.buttons) do
		if mx > button.x and mx < button.x + button.font:getWidth(button.text)
		and my > button.y and my < button.y + button.font:getHeight(button.text) then
			button:hover()
		else
			button:idle()
		end
	end
end

function HelpState:destroy()
end

function HelpState:setCallbacks()
	
	function love.mousereleased(x, y, k)
		for _, button in ipairs (self.buttons) do
			if x > button.x and x < button.x + button.font:getWidth(button.text)
			and y > button.y and y < button.y + button.font:getHeight(button.text)
			and k == "l" then
				button:click()
			end
		end
	end
end