----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------

Paddle = class("Paddle")

function Paddle:initialize(x, y, w, h)  
	local lp = love.physics
	--the shape attaches from its center so we position the body to be in the center of the shape
	--by adding 1/2 the width and 1/2 the height to x and y we should get the desired results
	self.body = lp.newBody(world, x + w/2, y + h/2, "kinematic" ) --will need to be Dynamic or Kinematic
	self.shape = lp.newRectangleShape(w, h)
	self.fixture = lp.newFixture(self.body, self.shape) -- attach the two!
	self.fixture:setUserData("Paddle")
end

function Paddle:draw()
	local lg = love.graphics
	lg.setColor(255, 255, 255)
	lg.polygon("fill", self.body:getWorldPoints(self.shape:getPoints()))
end

function Paddle:update(dt)
	if love.keyboard.isDown("right") then
		self.body:setLinearVelocity(250, 0)
	elseif love.keyboard.isDown("left") then
		self.body:setLinearVelocity(-250, 0)
	else
		self.body:setLinearVelocity(0, 0)
	end
end

function Paddle:destroy()
end
