----------------------------------------------------------------------------
-- project:			
-- file: 			
-- author:			Michael Groll
-- version:			
-- gitHub:			
--
-- description:     
----------------------------------------------------------------------------
TitleState = class("TitleState") -- The Title Screen
-- middleclass works by calling initialize when you create something, 
-- In main.lua I will do title = TitleState() which is the same as doing
-- title = TitleState:new()
-- new() and initialize() share arguments so any arguments you use when creating
-- an instance of your class, is sent to initialize()


-- every class needs one
function TitleState:initialize()   -- pretty much the same as load(), can have arguments
	-- our two must haves for states
	self.alwaysUpdate = false
	self.alwaysDraw = false
	-- here we would load our fonts
	-- colors
	love.graphics.setBackgroundColor(0, 0, 0)
	-- music
	-- buttons
	self.buttons = {}
	self.buttons[#self.buttons+1] = Button(WIDTH/2 - 75, HEIGHT/2 - 125, "New Game", "game" )
	self.buttons[#self.buttons+1] = Button(WIDTH/2 - 75, HEIGHT/2 - 50, "Options", "options")
	self.buttons[#self.buttons+1] = Button(WIDTH/2 - 75, HEIGHT/2 + 25, "Help", "help")
	self.buttons[#self.buttons+1] = Button(WIDTH/2 - 75, HEIGHT/2 + 100, "Exit", "exit")
	-- other things a TitleState might need
end

function TitleState:update(dt)
	-- music change?
	-- button manipulation?
	-- movement?
	local mx = love.mouse.getX()
	local my = love.mouse.getY()
	
	for _, button in ipairs(self.buttons) do
		if mx > button.x and mx < button.x + button.font:getWidth(button.text)
		and my > button.y and my < button.y + button.font:getHeight(button.text) then
			button:hover()
		else
			button:idle()
		end
	end
end

function TitleState:draw()
	for _ = 1, #self.buttons do
		if self.buttons[_] then self.buttons[_]:draw() end
	end
end

function TitleState:setCallbacks()
	-- here we can handle callBacks for this particular state
	-- Mouse and keyboard presses, or I believe physics call backs as well
	function love.keypressed(k)
		if k == "escape" then love.event.push('quit') end
	end
	
	function love.mousereleased(x, y, k)
	print(k)
		for _, button in ipairs(self.buttons) do
			if x > button.x and x < button.x + button.font:getWidth(button.text)
			and y > button.y and y < button.y + button.font:getHeight(button.text) 
			and k == "l" then
				button:click()				
			end
		end
	end
end
	
function TitleState:destroy()

end
	



